-- ADDRESS DECORDER
--		Ver1.0	Date 2000.09.07
--				Produced by Simamu
--		Ver2.0	Date 2000.10.31
--				Produced by Simamu
--		Ver3.0	Date 2000.12.26
--				Produced by Simamu
--		Ver3.1	Date 2000.12.27
--				Produced by Simamu
--		Ver3.2	Date 2000.12.28
--				Produced by Simamu
--		Ver3.3	Date 2001.01.09
--				Produced by Simamu

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ADD_DEC IS
	PORT
	(
		SA					: IN	STD_LOGIC_VECTOR(15 DOWNTO 1);
		LCD_ADD0,LCD_ADD1	: OUT 	STD_LOGIC;
		MPC_ADD0,MPC_ADD1	: OUT	STD_LOGIC;
		RE_ADD0,RE_ADD1		: OUT	STD_LOGIC;
		USS_ADD0,USS_ADD1	: OUT	STD_LOGIC;
		TIP_ADD0,TIP_ADD1	: OUT	STD_LOGIC;
		IOCS16n				: OUT	STD_LOGIC
	);
END ADD_DEC;

ARCHITECTURE DATAFLOW OF ADD_DEC IS
BEGIN
LCD_ADD1 <= SA(1);
PROCESS (SA)
BEGIN
	CASE SA IS
		WHEN "000000010000000"
			|"000000010000001"	=>	LCD_ADD0 	<= '1';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010001000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '1';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010001001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '1';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010010000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '1';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010010001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '1';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010011000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '1';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010011001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '1';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010100000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '1';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '1';
		WHEN "000000010100001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '1';
									IOCS16n 	<= '1';
		WHEN OTHERS				=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TIP_ADD0 	<= '0';
									TIP_ADD1 	<= '0';
									IOCS16n 	<= '0';
	END CASE;
END PROCESS;
END DATAFLOW;

