LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY ENCODER IS
	PORT
	(
		D		: IN	STD_LOGIC_VECTOR(1 downto 0);
		B_IOWN	: IN	STD_LOGIC;
		ADD_DEC	: IN	STD_LOGIC_VECTOR(1 downto 0);
		X		: OUT	STD_LOGIC_VECTOR(3 downto 0);
		Y		: OUT	STD_LOGIC_VECTOR(1 downto 0);
		Z		: OUT	STD_LOGIC);
END ENCODER;

ARCHITECTURE RTL OF ENCODER IS
	SIGNAL	B	: STD_LOGIC;
	SIGNAL	C	: STD_LOGIC;
begin
C <= ADD_DEC(0) and not B_IOWN;
B <= ADD_DEC(1) and not B_IOWN;
Z <= C;
process(C,B)
begin
	if (C'event and C='1') then
		case D is
		when "00" => X <= "0001";
		when "01" => X <= "0010";
		when "10" => X <= "0100";
		when "11" => X <= "1000";
		when others	=> X <= "0000";
		end case;
	end if;
	if (B'event and B='1') then
		Y <= D;
	end if;
end process;
end RTL;




