LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRS_LATCH_0105 IS
	PORT
	(
		IRS_IN0				: IN	STD_LOGIC_VECTOR(12 DOWNTO 0);
		FLAG				: IN	STD_LOGIC;
		IO_R				: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		IRSOUT				: out	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END IRS_LATCH_0105;
ARCHITECTURE RTL OF IRS_LATCH_0105 IS
	SIGNAL	IRSDUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN	
	PROCESS(B_CLK)
	BEGIN
		if(B_RESET='1') then
			IRSDUM <= "0000000000000000";
		elsif(B_CLK'EVENT AND B_CLK = '1') then
			if(IO_R='1' and FLAG='1')then
				IRSDUM(15) <= IRS_IN0(12);
				IRSDUM(14) <= '0';
				IRSDUM(13) <= '0';
				IRSDUM(12) <= '0';
				IRSDUM(11 downto 0) <= IRS_IN0(11 downto 0);
			end if;
		end if;
	end process;
IRSOUT <= IRSDUM;
end RTL;

