LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRS_SEL IS
	PORT
	(
		IOWN,reset			: IN	STD_LOGIC;
		IRS_RS				: IN	STD_LOGIC;
		DATA_IN				: IN	STD_LOGIC;
		IR_S				: IN	STD_LOGIC_VECTOR(1 downto 0);
		IRS_NUM				: OUT	STD_LOGIC;
		IR_OUT				: OUT 	STD_LOGIC
	);
	
END IRS_SEL;
ARCHITECTURE RTL OF IRS_SEL IS
SIGNAL IRS_SELECT : std_logic;
begin
	process(IOWN)
	begin
		if(reset = '1') then	
			IRS_SELECT <= '0';			
		elsif (IOWN'EVENT and IOWN = '0') then	
			if(IRS_RS = '1') then	
				IRS_SELECT <= DATA_IN;
			else
				IRS_SELECT <= IRS_SELECT;
			end if;
		end if;	
	end process;
	process(IRS_SELECT)
	begin
		case IRS_SELECT is
			when '0' => IR_OUT <= not IR_S(0);
			when '1' => IR_OUT <= not IR_S(1);
			when others => IR_OUT <= '0';
		end case;
	end process;
	IRS_NUM <= IRS_SELECT;
END RTL;

