LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY TP_LATCH IS
	PORT
	(
		TSIN				: IN	STD_LOGIC_VECTOR(5 DOWNTO 0);
		LSIN				: IN	STD_LOGIC_VECTOR(2 DOWNTO 0);
		RESET,PO_IN			: IN	STD_LOGIC;
		TIP_ADD1			: IN	STD_LOGIC;
		B_IOWN,B_IORN		: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		TPOUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END TP_LATCH;

ARCHITECTURE RTL OF TP_LATCH IS
	SIGNAL	TPDUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN
	PROCESS (B_CLK,B_RESET) begin
		if(B_RESET='1')then
			TPDUM <= "0000000000000000";
		elsif(B_CLK'event and B_CLK='1')then
			if(B_IOWN='0' and TIP_ADD1='1' and RESET='1')then
				TPDUM <="0000000000000000";
			elsif(B_IORN='1')then
				TPDUM(0) <= PO_IN;
				TPDUM(6 downto 1) <= TSIN;
				TPDUM(7) <= '0';
				TPDUM(10 downto 8) <= not LSIN;
				TPDUM(15 downto 11) <= "00000";
			end if;
		end if;
	END PROCESS;
TPOUT <= TPDUM;
END RTL;

