LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY USS_ENCODER IS
	PORT
	(
		B_SD	: IN	STD_LOGIC_VECTOR(1 downto 0);
		B_IOWN	: IN	STD_LOGIC;
		ADD_DEC	: IN	STD_LOGIC_VECTOR(1 downto 0);
		USS_SEL	: OUT	STD_LOGIC_VECTOR(1 downto 0);
		MASK	: OUT	STD_LOGIC;
		RESET	: OUT	STD_LOGIC;
		Z		: OUT	STD_LOGIC);
END USS_ENCODER;

ARCHITECTURE RTL OF USS_ENCODER IS
	SIGNAL	B	: STD_LOGIC;
	SIGNAL	C	: STD_LOGIC;
begin
C <= ADD_DEC(0) and not B_IOWN;
B <= ADD_DEC(1) and not B_IOWN;
Z <= C;
process(C,B)
begin
	if (C'event and C='1') then
		case B_SD(0) is
		when '0' => USS_SEL <= "01";
		when '1' => USS_SEL <= "10";
		when others	=> USS_SEL <= "00";
		end case;
	end if;
	if (B'event and B='1') then
		MASK <= B_SD(1);
	end if;
end process;
RESET <= B_SD(0) and B;
end RTL;




